import os
import datetime
import example_demo.commons.common_fun as common
from example_demo.commons.common_cfg import get_cfg_data


class BaseUrlSource(object):

    def init_setting_source(self):
        pass

    def parse_setting_url(self):
        pass

    @property
    def name(self):
        return self.__class__.__name__

    def close(self):
        pass


PROJECT_NAME = ''

# [邮件]
EMAIL_ENABLE = 0
EMAIL_HOST = ''
EMAIL_FROM = ''
EMAIL_USER_NAME = ''
EMAIL_TO_LIST = ''
EMAIL_CC = ''
EMAIL_SUBJECT = ''

# [pipeline]
PIPELINE_ENABLE = 0
PIPELINE_REDIS_SERVER_IP = ''
PIPELINE_REDIS_SERVER_PORT = ''
PIPELINE_PROXY_IP = ''
PIPELINE_DOMAIN_NAME = ''


# [tel]
TEL_ENABLE = 0
TEL_RECEIVER = ''
# TEL_SUB_DATE_TYPE = ''
# TEL_REMIND_INFO = ''
# TEL_TEMPLATE_NO = ''
# TEL_STATUS = ''
# TEL_CALLTIMES = ''
# TEL_MEMO = ''

# [redis]
REDIS_ENABLE = 0
REDIS_HOST = ''
REDIS_PORT = ''
REDIS_PASSWORD = ''
REDIS_LOAD_DB = ''
REDIS_PROXY_DB = ''
#
# REDIS_SLAVER = ''
# REDIS_VALUE0 = ''
# REDIS_VALUE1 = ''

# [dpool]
DPOOL_ENABLE = 0

# [ldb]
LDB_ENABLE = 0
LDB_TARGET = ''
LDB_SCHEMA = ''


# [debug]
DEBUG_ENABLE = 1

# [clean]
CLEAN_WARNING = ''
CLEAN_ERROR = ''

# [source]
SOURCE_CUSTOMIZE = 1
SOURCE_DATE = ''
SOURCE_REQUEST_TYPE = ''

SOURCE_FILE_TARGET_PATH = ''
SOURCE_REAL_FILE_TARGET_PATH = ''
SOURCE_LOCAL_LOAD_DIR_CACHE = ''

# api
SOURCE_URL_FORMAT = ''
SOURCE_URL_PARAMS = {}
SOURCE_URL_START_PAGE = ''
SOURCE_URL_STOP_PAGE_NUM = ''
SOURCE_URL_PAGESIZE = ''
SOURCE_REQUEST_TIMEOUT = 10
SOURCE_NEED_UA = False
SOURCE_DEFAULT_UA = ''
SOURCE_REQUEST_AUTH_NAME = ''
SOURCE_REQUEST_AUTH_PASSWORD = ''


# sftp
SOURCE_SFTP_HOST = ''
SOURCE_SFTP_PORT = ''
SOURCE_SFTP_USER = ''
SOURCE_SFTP_PASSWORD = ''

SOURCE_SFTP_FILE = ''
SOURCE_SFTP_LOAD_PATH = ''
SOURCE_SFTP_OUT_PATH = ''
SOURCE_SFTP_OUTPUT_DIR = ''
SOURCE_SFTP_REAL_OUTPUT_DIR = ''
SOURCE_SFTP_UNZIP_PATH = ''
SOURCE_SFTP_PATH_TEST = ''
SOURCE_SFTP_LOAD_FILE_MINSIZE = ''


# ftp
SOURCE_FTP_IP = ''
SOURCE_FTP_PORT = ''
SOURCE_FTP_USER_ID = ''
SOURCE_FTP_USER_PASSWORD = ''
SOURCE_FTP_DIR = ''

SOURCE_FTP_TARGET_DIR = ''
SOURCE_FTP_REAL_TARGET_DIR = ''
program_config = {}

setting_info = {}


def init_cfg():
    global PROJECT_NAME

    global EMAIL_ENABLE
    global EMAIL_HOST
    global EMAIL_TO_LIST
    global EMAIL_CC
    global EMAIL_SUBJECT
    global EMAIL_FROM
    global EMAIL_USER_NAME

    global PIPELINE_ENABLE
    global PIPELINE_REDIS_SERVER_IP
    global PIPELINE_REDIS_SERVER_PORT
    global PIPELINE_PROXY_IP
    global PIPELINE_DOMAIN_NAME

    global TEL_ENABLE
    global TEL_RECEIVER

    global REDIS_ENABLE
    global REDIS_HOST
    global REDIS_PORT
    global REDIS_PASSWORD
    global REDIS_LOAD_DB
    global REDIS_PROXY_DB

    global DPOOL_ENABLE

    global DEBUG_ENABLE

    global SOURCE_CUSTOMIZE
    global SOURCE_REQUEST_TYPE
    global SOURCE_DATE

    global SOURCE_REQUEST_TIMEOUT
    global SOURCE_URL_FORMAT
    global SOURCE_URL_PARAMS
    global SOURCE_URL_START_PAGE
    global SOURCE_URL_STOP_PAGE_NUM
    global SOURCE_URL_PAGESIZE
    global SOURCE_NEED_UA
    global SOURCE_DEFAULT_UA
    global SOURCE_REQUEST_AUTH_NAME
    global SOURCE_REQUEST_AUTH_PASSWORD

    global SOURCE_FILE_TARGET_PATH
    global SOURCE_REAL_FILE_TARGET_PATH
    global SOURCE_LOCAL_LOAD_DIR_CACHE

    global SOURCE_SFTP_HOST
    global SOURCE_SFTP_PORT
    global SOURCE_SFTP_USER
    global SOURCE_SFTP_PASSWORD

    global SOURCE_SFTP_OUTPUT_DIR
    global SOURCE_SFTP_REAL_OUTPUT_DIR
    global SOURCE_SFTP_UNZIP_PATH
    global SOURCE_SFTP_PATH_TEST
    global SOURCE_SFTP_LOAD_FILE_MINSIZE

    global SOURCE_FTP_IP
    global SOURCE_FTP_PORT
    global SOURCE_FTP_USER_ID
    global SOURCE_FTP_USER_PASSWORD
    global SOURCE_FTP_DIR
    global SOURCE_FTP_TARGET_DIR
    global SOURCE_FTP_REAL_TARGET_DIR

    global program_config

    CONFIG_FILE = "project.cfg"
    cfg_path = (os.path.join(os.getcwd(), CONFIG_FILE))
    if not common.check_path(cfg_path):
        print('no cfg!!')
        return
    print('--------init_cfg')
    program_config = get_cfg_data(cfg_path, need_dict=True)
    PROJECT_NAME = common.try_get(program_config, ["project", "name"])
    print(program_config)
    PIPELINE_REDIS_SERVER_IP = common.try_get(program_config, ["pipeline", "redis_server_ip"])
    PIPELINE_REDIS_SERVER_PORT = common.try_get(program_config, ["pipeline", "redis_server_port"])
    PIPELINE_PROXY_IP = common.try_get(program_config, ["pipeline", "proxy_ip"])
    PIPELINE_DOMAIN_NAME = common.try_get(program_config, ["pipeline", "domain_name"])

    TEL_ENABLE = common.try_int(common.try_get(program_config, ["tel", "enable"]))
    TEL_RECEIVER = common.try_get(program_config, ["tel", "receiver"])
    if TEL_RECEIVER:
        TEL_RECEIVER = TEL_RECEIVER.split(";")

    REDIS_ENABLE = common.try_int(common.try_get(program_config, ["redis", "enable"]))
    REDIS_HOST = common.try_get(program_config, ["redis", "host"])
    REDIS_PORT = common.try_get(program_config, ["redis", "port"])
    REDIS_PASSWORD = common.try_get(program_config, ["redis", "password"])
    REDIS_LOAD_DB = common.try_get(program_config, ["redis", "load_db"])
    REDIS_PROXY_DB = common.try_get(program_config, ["redis", "proxy_db"])

    EMAIL_ENABLE = common.try_int(common.try_get(program_config, ["email", "enable"]))
    EMAIL_HOST = common.try_get(program_config, ["email", "host"])
    EMAIL_FROM = common.try_get(program_config, ["email", "from"])
    EMAIL_USER_NAME = common.try_get(program_config, ["email", "user_name"])
    EMAIL_TO_LIST = common.try_get(program_config, ["email", "to"])
    EMAIL_CC = common.try_get(program_config, ["email", "cc"])
    if EMAIL_TO_LIST:
        EMAIL_TO_LIST = EMAIL_TO_LIST.split(";")
    if EMAIL_CC:
        EMAIL_CC = EMAIL_CC.split(";")
    EMAIL_SUBJECT = common.try_get(program_config, ["email", "subject"])

    DEBUG_ENABLE = common.try_int(common.try_get(program_config, ["debug", "enable"]))

    SOURCE_CUSTOMIZE = common.try_get(program_config, ["source", "customize"])
    SOURCE_DATE = common.try_get(program_config, ["source", "date"])

    # 默认时间前一天， ；支持 直接输入的 %Y-%m-%d 是否支持识别切换工作日和正常日期
    # 时间，支持 直接输入的 %Y-%m-%d；workday 前一天工作日；day（默认） 前一天;
    if not SOURCE_DATE:
        SOURCE_DATE = (datetime.date.today() - datetime.timedelta(days=1)).strftime(
            '%Y-%m-%d')
    SOURCE_REQUEST_TYPE = common.try_get(program_config, ["source", "request_type"])
    SOURCE_REQUEST_TIMEOUT = common.try_get(program_config, ["source", "request_timeout"])
    SOURCE_NEED_UA = common.try_get(program_config, ["source", "need_ua"])
    SOURCE_DEFAULT_UA = common.try_get(program_config, ["source", "default_ua"])
    SOURCE_URL_FORMAT = common.try_get(program_config, ["source", "url_format"])
    print(SOURCE_URL_FORMAT)
    url_params = common.try_get(program_config, ["source", "url_params"])
    if url_params:
        url_params = url_params.split(';')
        for para in url_params:
            if not para:
                continue
            para_k, para_v = para.split('->')
            SOURCE_URL_PARAMS[para_k] = para_v
    SOURCE_URL_START_PAGE = common.try_int(common.try_get(program_config, ["source", "url_start_page"]))
    SOURCE_URL_STOP_PAGE_NUM = common.try_int(common.try_get(program_config, ["source", "url_stop_page_num"]))
    SOURCE_URL_PAGESIZE = common.try_int(common.try_get(program_config, ["source", "url_pagesize"]))

    SOURCE_REQUEST_AUTH_NAME = common.try_get(program_config, ["source", "request_auth_name"])
    SOURCE_REQUEST_AUTH_PASSWORD = common.try_get(program_config, ["source", "request_auth_password"])

    SOURCE_FILE_TARGET_PATH = common.try_get(program_config, ["source", "file_target_path"])
    SOURCE_REAL_FILE_TARGET_PATH = common.try_get(program_config, ["source", "real_file_target_path"])
    SOURCE_LOCAL_LOAD_DIR_CACHE = common.try_get(program_config, ["source", "local_load_dir_cache"])

    SOURCE_SFTP_HOST = common.try_get(program_config, ["source", "sftp_host"])
    SOURCE_SFTP_PORT = common.try_get(program_config, ["source", "sftp_port"])
    SOURCE_SFTP_USER = common.try_get(program_config, ["source", "sftp_user"])
    SOURCE_SFTP_PASSWORD = common.try_get(program_config, ["source", "sftp_password"])
    # SFTP_USER_2 = common.try_get(program_config, ["url_source", "sftp_user_2"])
    # SFTP_PASSWORD_2 = common.try_get(program_config, ["url_source", "sftp_user_password_ase2"])
    if SOURCE_SFTP_USER and SOURCE_SFTP_PASSWORD:
        SOURCE_SFTP_USER = SOURCE_SFTP_USER.split(";")
        SOURCE_SFTP_PASSWORD = SOURCE_SFTP_PASSWORD.split(";")

    SOURCE_SFTP_OUTPUT_DIR = common.try_get(program_config, ["source", "sftp_output_dir"])
    SOURCE_SFTP_UNZIP_PATH = common.try_get(program_config, ["source", "sftp_unzip_path"])
    SOURCE_SFTP_PATH_TEST = common.try_get(program_config, ["source", "sftp_path_test"])
    SOURCE_SFTP_LOAD_FILE_MINSIZE = common.try_get(program_config, ["source", "sftp_load_file_minsize"], default_value=0)
    SOURCE_SFTP_REAL_OUTPUT_DIR = common.try_get(program_config, ["source", "sftp_real_output_dir"])

    SOURCE_FTP_IP = common.try_get(program_config, ["source", "ftp_ip"])
    SOURCE_FTP_PORT = common.try_get(program_config, ["source", "ftp_port"])
    SOURCE_FTP_USER_ID = common.try_get(program_config, ["source", "ftp_user_id"])
    SOURCE_FTP_USER_PASSWORD = common.try_get(program_config, ["source", "ftp_user_password"])
    SOURCE_FTP_DIR = common.try_get(program_config, ["source", "ftp_dir"])

    SOURCE_FTP_TARGET_DIR = common.try_get(program_config, ["source", "ftp_target_dir"])
    SOURCE_FTP_REAL_TARGET_DIR = common.try_get(program_config, ["source", "ftp_real_target_dir"])

    DPOOL_ENABLE = common.try_int(common.try_get(program_config, ["dpool", "enable"]))


try:
    init_cfg()
    setting_info = dict(
        project_name=PROJECT_NAME,

        pipeline_redis_server_ip=PIPELINE_REDIS_SERVER_IP,
        pipeline_redis_server_port=PIPELINE_REDIS_SERVER_PORT,
        pipeline_proxy_ip=PIPELINE_PROXY_IP,
        pipeline_domain_name=PIPELINE_DOMAIN_NAME,

        tel_enable=TEL_ENABLE,
        tel_receiver=TEL_RECEIVER,

        redis_enable=REDIS_ENABLE,
        redis_host=REDIS_HOST,
        redis_port=REDIS_PORT,
        redis_password=REDIS_PASSWORD,
        redis_load_db=REDIS_LOAD_DB,
        redis_proxy_db=REDIS_PROXY_DB,

        email_enable=EMAIL_ENABLE,
        email_host=EMAIL_HOST,
        email_from=EMAIL_FROM,
        email_user_name=EMAIL_USER_NAME,
        email_subject=EMAIL_SUBJECT,
        email_cc=EMAIL_CC,
        email_to_list=EMAIL_TO_LIST,

        debug_enable=DEBUG_ENABLE,

        source_customize=SOURCE_CUSTOMIZE,
        source_request_type=SOURCE_REQUEST_TYPE,

        source_request_timeout=SOURCE_REQUEST_TIMEOUT,
        source_need_ua=SOURCE_NEED_UA,
        source_default_ua=SOURCE_DEFAULT_UA,
        source_request_auth_name=SOURCE_REQUEST_AUTH_NAME,
        source_request_auth_password=SOURCE_REQUEST_AUTH_PASSWORD,

        source_url_format=SOURCE_URL_FORMAT,
        source_url_params=SOURCE_URL_PARAMS,
        source_url_start_page=SOURCE_URL_START_PAGE,
        source_url_stop_page_num=SOURCE_URL_STOP_PAGE_NUM,
        source_url_pagesize=SOURCE_URL_PAGESIZE,



        source_sftp_host=SOURCE_SFTP_HOST,
        source_sftp_port=SOURCE_SFTP_PORT,
        source_sftp_user=SOURCE_SFTP_USER,
        source_sftp_password=SOURCE_SFTP_PASSWORD,

        source_ftp_ip=SOURCE_FTP_IP,
        source_ftp_port=SOURCE_FTP_PORT,
        source_ftp_user_id=SOURCE_FTP_USER_ID,
        source_ftp_user_password=SOURCE_FTP_USER_PASSWORD,


        # 涉及文件下载路径，业务项目普遍有下载转存需求，这里对不同下载方式下载路径做了区分
        # 是否可以统一？暂不统一，看后续业务项目再调整
        source_file_target_path=SOURCE_FILE_TARGET_PATH,
        source_real_file_target_path=SOURCE_REAL_FILE_TARGET_PATH,
        source_local_load_dir_cache=SOURCE_LOCAL_LOAD_DIR_CACHE,

        source_ftp_target_dir=SOURCE_FTP_TARGET_DIR,
        source_ftp_real_target_dir=SOURCE_FTP_REAL_TARGET_DIR,
        source_sftp_out_dir=SOURCE_SFTP_OUTPUT_DIR,
        source_sftp_real_out_dir=SOURCE_SFTP_REAL_OUTPUT_DIR,
        source_sftp_unzip_path=SOURCE_SFTP_UNZIP_PATH,
        source_sftp_path_test=SOURCE_SFTP_PATH_TEST,
        source_sftp_load_file_minsize=SOURCE_SFTP_LOAD_FILE_MINSIZE,


        dpool_enable=DPOOL_ENABLE

    )
    if DEBUG_ENABLE:
        print(SOURCE_URL_FORMAT)
        print(setting_info)
except:
    pass
